Subject: Re: [PATCH] iproute2: fix type incompatibility in ifstat.c

From: Florian Weimer <[email-masked]>
Date: Wed, 07 Feb 2024 07:44:59 +0100

* Stephen Hemminger:

> On Tue,  6 Feb 2024 09:22:06 -0500
> Stephen Gallagher <[email-masked]> wrote:
>
>> Throughout ifstat.c, ifstat_ent.val is accessed as a long long unsigned
>> type, however it is defined as __u64. This works by coincidence on many
>> systems, however on ppc64le, __u64 is a long unsigned.
>> 
>> This patch makes the type definition consistent with all of the places
>> where it is accessed.
>> 
>> Signed-off-by: Stephen Gallagher <[email-masked]>
>> ---

Patch was:

diff --git a/misc/ifstat.c b/misc/ifstat.c
index 721f4914..767cedd4 100644
--- a/misc/ifstat.c
+++ b/misc/ifstat.c
@@ -58,7 +58,7 @@ struct ifstat_ent {
 	struct ifstat_ent	*next;
 	char			*name;
 	int			ifindex;
-	__u64			val[MAXS];
+	unsigned long long	val[MAXS];
 	double			rate[MAXS];
 	__u32			ival[MAXS];
 };

> Why not fix the use of unsigned long long to be __u64 instead?
> That would make more sense.

You still won't be able to use %llu to print it.  I don't think the UAPI
headers provide anything like the <stdint.h> macros because the
assumption is that %llu is okay for printing __u64 on all architectures.

But we have this in POWER:

/*
 * This is here because we used to use l64 for 64bit powerpc
 * and we don't want to impact user mode with our change to ll64
 * in the kernel.
 *
 * However, some user programs are fine with this.  They can
 * flag __SANE_USERSPACE_TYPES__ to get int-ll64.h here.
 */
#if !defined(__SANE_USERSPACE_TYPES__) && defined(__powerpc64__) && !defined(__KERNEL__)
# include <asm-generic/int-l64.h>
#else
# include <asm-generic/int-ll64.h>
#endif

I didn't know some architectures are that … different.  Sadly this
wasn't fixed as part of the transition to powerpc64le.

I suppose iproute2 should build with -D__SANE_USERSPACE_TYPES__.

Thanks,
Florian